<?php

/**
 * AdminSubcategoria
 * Classe responsavel pelo controle das subcategorias
 * @copyrigth 2017, Welton Thierree TagPage
 */
class AdminSubcategoria {

    private $Data;
    private $CatId;
    private $Result;
    private $Error;

    //nome da tabela no banco de dados
    const Entidy = "app_subcategorias";

    public function ExeCreate(array $Data) {
        $this->Data = $Data;
        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['<b>Erro ao cadastrar</b> Preencha o campo categoria', WS_ALERT];
        else:
            $this->setData();
            $this->setName();
            $this->Create();
        endif;
    }

    public function ExeUpdate($CatId, array $Data) {
        $this->CatId = (int) $CatId;
        $this->Data = $Data;
        
        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['Preencha o campo categoria', WS_ALERT];
        else:
            $this->setData();
            $this->setName();
            $this->Update();
        endif;
    }
    
    public function ExeDelete($CatId) {
        $this->CatId = (int) $CatId;

        $Read = new Read;
        $Read->ExeRead(self::Entidy, "WHERE subcategoria_id = :catid", "catid={$this->CatId}");

        if (!$Read->getResult()):
            $this->Result = false;
            $this->Error = ['Oppss, você tentou remover uma subcategoria que não existe no sistema!', WS_INFOR];
        else:
            extract($Read->getResult()[0]);
            if (!$this->CheckSub()):
                $this->Result = false;
                $this->Error = ["A <b>subcategoria {$subcategoria_nome}</b> possui subcategorias cadastradas. Para deletar, antes altere ou remova as subcategorias!", WS_ALERT];
            else:
                $Delete = new Delete;
                $Delete->ExeDelete(self::Entidy, "WHERE subcategoria_id = :delId", "delId={$this->CatId}");
                $this->Result = true;
                $this->Error = ["A <b>subcategoria {$subcategoria_titulo}</b> foi removida com sucesso!", WS_ACCEPT];
            endif;
        endif;
    }

    function getResult() {
        return $this->Result;
    }

    function getError() {
        return $this->Error;
    }

    //Private
    private function setData() {
        $this->Data = array_map('strip_tags', $this->Data);
        $this->Data = array_map('trim', $this->Data);
        $this->Data['subcategoria_nome'] = Check::Name($this->Data['subcategoria_titulo']);
        $this->Data['subcategoria_data'] = date('Y-m-d H:i:s');
    }
    
    private function setName() {
        $Where = (!empty($this->CatId) ? "subcategoria_id != {$this->CatId} AND" : '');

        $readName = new Read;
        $readName->ExeRead(self::Entidy, "WHERE {$Where} subcategoria_titulo = :t", "t={$this->Data['subcategoria_titulo']}");
        if ($readName->getResult()):
            $this->Data['subcategoria_nome'] = $this->Data['subcategoria_nome'] . '-' . $readName->getRowCount();
        endif;
    }

    private function CheckSub() {
        $ReadSub = new Read;
        $ReadSub->ExeRead("tp_creditos", "WHERE subcategoria_id = :catid", "catid={$this->CatId}");
        if ($ReadSub->getResult()):
            return false;
        else:
            return true;
        endif;
    }

    private function Create() {
        $Create = new Create;
        $Create->ExeCreate(self::Entidy, $this->Data);
        if ($Create->getResult()):
            $this->Result = $Create->getResult();
            $this->Error = ["<b>Sucesso:</b> A subcategoria {$this->Data['subcategoria_titulo']} foi cadastrada no sistema", WS_ACCEPT];
        endif;
    }
    
    private function Update() {
        $Update = new Update;
        $Update->ExeUpdate(self::Entidy, $this->Data, "WHERE subcategoria_id = :subid", "subid={$this->CatId}");
        if ($Update->getResult()):
            $this->Result = true;
            $this->Error = ["<b>Sucesso:</b> A subcategoria {$this->Data['subcategoria_titulo']} foi atualizada no sistema", WS_ACCEPT];
        endif;
    }

}
